SystemOrganization addCategory: #Seaside28Jetsam!
SystemOrganization addCategory: #'Seaside28Jetsam-Info'!
SystemOrganization addCategory: #'Seaside28Jetsam-Tests'!
SystemOrganization addCategory: #'Seaside28Jetsam-Document'!
SystemOrganization addCategory: #'Seaside28Jetsam-Tests-Functional'!
SystemOrganization addCategory: #'Seaside28Jetsam-Libraries'!

!WAImageTag methodsFor: '*js-accessing' stamp: 'kph 7/11/2007 22:22'!
fileName: aFileName
	self deprecatedApi.
	self document: (WACachedDocument fileName: aFileName)! !

WAStandardFiles subclass: #WAStandardFilesPlus
	instanceVariableNames: 'fileNames directory fileSelectors'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Libraries'!

!WAStandardFilesPlus commentStamp: 'kph 7/19/2007 20:24' prior: 0!
The majority of seaside projects need to have WAStandardFiles included otherwise such things as the toolbar cease to display properly.

This class inherits from WAStandardFiles and so by subclassing me, and adding your subclass to your project (e.g. MyFiles)
you can override the defaults. I also add some features.

Note the following example, in which the filename may be used to reference a file in your generation code.

html image url: (MyFiles / 'logo.gif').

In standard seaside the file selector form #logoGif would be used. In a shameless hack which would never be accepted in seaside proper, we enable both forms. A symbol is assumed to be a selector reference, and a string is assumed to be a file reference. We do this simply because, in situations where you may be asking a user to specify a file via a settings interface, they are likely to be more familiar with the filename form. The filename form is also cannonical.

Your subclass can also specify whether or not it caches DISK (i.e. not those stored in a file library method selector aka WAStandardFiles) based documents, by defining #documentClass. By default we serve non-cached documents (i.e. we do not cache the document, and we request that the browser does not either), but once your project is defined you may wish to change that.

We keep a cache the fileNames of those files we have available to serve from disk.
In an extra-ordinary hack we reset this cache whenever #miscJs is accessed which is likely to happen once per user session. This may not be appropriate and better ideas are very welcome!!


!

!WAStandardFilesPlus class methodsFor: 'generating html' stamp: 'kph 7/19/2007 20:30'!
libraryName

	^ 'seaside'! !

!WAStandardFilesPlus class methodsFor: 'generating html' stamp: 'kph 7/19/2007 18:56'!
/ aSymbolOrFileNameString

	aSymbolOrFileNameString isSymbol 
		ifTrue: [ ^ self default urlOf: aSymbolOrFileNameString ]
		ifFalse: [ ^ self default urlForFile: aSymbolOrFileNameString ]! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 19:56'!
documentAt: aFilename ifAbsent: aBlock
	
	| doc response |
 
	(self fileNames includes: aFilename) 
		ifFalse: [ ^ super documentAt: aFilename ifAbsent: aBlock ].
 
	doc := (self documentClass
			fileName:  (self libraryName, FileDirectory slash , aFilename)) asMIMEDocument.
	 
	response := WAResponse new.
	response contents: doc contentStream text.
	response contentType: doc mimeType.
 
	(doc respondsTo: #notCached) 
		ifTrue: [ response doNotCache ]
		ifFalse: [ response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT' ].

 	response attachmentWithFileName: aFilename.

	^ response! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 19:40'!
documentClass
	
	^ WANotCachedDocument

	"or WANotCachedDocument"! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:33'!
fileNames

	| dir |

	^ fileNames ifNil: [ 

		(dir := self libraryDirectory) exists ifFalse:[ ^ #() ].

		fileNames := dir fileNames 
	].! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:25'!
fileSelectors
	"we inherit and cache our fileSelectors whereas standard file libraries do not."
 
	^ fileSelectors ifNil:[

		fileSelectors :=  IdentitySet new.
		(self class withAllSuperclasses upTo: WAFileLibrary)  do:
			[:aClass | fileSelectors addAll: aClass selectors].

		fileSelectors := (fileSelectors
			select: [ :each | self isFileSelector: each ])
			removeAllFoundIn: self nonFileSelectors;
			yourself.
	].! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:17'!
initialize


 ! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 19:32'!
libraryDirectory

	^ directory ifNil: [ directory := FileDirectory default directoryNamed: self libraryName ]! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:24'!
miscJs

	fileNames := nil.
	fileSelectors := nil.

	^ super miscJs! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:44'!
nonFileSelectors
	^#(
		documentClass
		fileNames
		fileSelectors
		initialize
		libraryDirectory
		libraryName
		nonFileSelectors
		selectorsToInclude
	)! !

!WAConfiguration methodsFor: '*js-testing' stamp: 'kph 7/19/2007 11:28'!
hasGroupNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea group = aSymbol]! !

TestCase subclass: #JetsamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Tests'!

!JetsamTestCase commentStamp: 'kph 7/19/2007 12:43' prior: 0!
JetsamTestCase tests for the presence of the fixes. This enables a quick if a little backwards method to assess whether a base version of seaside has any Jetsam fixes/extensions already present!!

Load seaside, just load JetsamTestCase (rather than the whole package), and if any tests "pass" then these could be candidates for removal from Jetsam.

!

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:37'!
test01HasPreferenceGroup

	self assert: ((WADispatcher default entryPointAt:'config') configuration hasGroupNamed: #authentication) ! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:37'!
test02ClearCachedDocument

	self assert: (WACachedDocument new respondsTo: #clear)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:37'!
test03IdNotNil

	self assert: (WATagBrush new respondsTo: #idNotNil:)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:37'!
test04ImageFilename

	self assert: (WAImageTag new respondsTo: #fileName:)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:38'!
test05HeadingLevel

	self assert: (WAHtmlCanvas new respondsTo: #heading:level:)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:43'!
test06downloadmimeTypefilename

	self assert: (WASession new respondsTo: #download:mimeType:filename:)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:54'!
test08totalSize

	self assert: (WABatchedList new respondsTo: #totalSize)! !

!WASession methodsFor: '*js' stamp: 'gk 3/22/2006 13:39'!
download: contents mimeType: mimeType filename: fileName
	self respond: [:url |
		(WAResponse new)
			contentType: mimeType;
			doNotCache;
			headerAt: 'Content-Disposition' put: 'attachment; filename="' , fileName , '"';
			headerAt: 'Content-length' put: contents size printString;
			contents: contents;
			yourself]
! !

!WABatchedList methodsFor: '*js' stamp: 'gk 11/15/2006 11:10'!
totalSize
	^items size! !

!WALibrary class methodsFor: '*js-resolving' stamp: 'kph 7/19/2007 20:29'!
libraryAt: aLibraryName

	^ self libraryName = aLibraryName   
		ifTrue: [ self default ] 
		ifFalse: [ nil ]! !

!WALibrary class methodsFor: '*js-resolving' stamp: 'kph 7/12/2007 10:26'!
libraryName

	^ self name! !

!WALibrary methodsFor: '*js-accessing' stamp: 'kph 7/12/2007 10:57'!
libraryName

	^ self class libraryName ! !

!WALibrary methodsFor: '*js-accessing' stamp: 'kph 7/14/2007 10:25'!
urlForFile: aFilename using: aHandler
	^ aHandler baseUrl
		addToPath: self libraryName;
		addToPath: aFilename;
		yourself! !

!WALibrary methodsFor: '*js' stamp: 'kph 7/14/2007 10:28'!
urlForFile: aFilename
	^ self urlForFile: aFilename using: WAFileHandler default
! !

!WALibrary methodsFor: '*js' stamp: 'kph 7/14/2007 10:31'!
urlOf: aSymbol
	^ self urlForFile: (self asFilename: aSymbol)! !

!WAFileHandler methodsFor: '*js-processing-override' stamp: 'kph 7/12/2007 10:13'!
libraryAt: aLibraryName ifAbsent: aBlock
	self librariesDo: [ :each |
 		(each libraryAt: aLibraryName) ifNotNilDo: [ :lib | ^ lib ] 
	].
	^ aBlock value! !

!WAFileHandler methodsFor: '*js-processing-override' stamp: 'kph 7/14/2007 09:56'!
responseAt: aPath ifAbsent: aBlock
	| libraryName fileName library |
	libraryName := aPath at: aPath size - 1.
	fileName := aPath last.

	library := self
		libraryAt: libraryName
		ifAbsent: [ ^ aBlock value ].
	^ library
		documentAt: fileName
		ifAbsent: aBlock! !

WAFunctionalTest subclass: #WAStandardFilesPlusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Tests-Functional'!

!WAStandardFilesPlusTest methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:41'!
label

^ 'File Handler+'! !

!WAStandardFilesPlusTest methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:35'!
renderContentOn: html

html text: 'This image is: inspector.png, to test place your own version in the local directory '' seaside''.'.
html image url: (WAStandardFilesPlus / 'inspector.png')! !

!WAHtmlCanvas methodsFor: '*js-deprecated' stamp: 'lr 7/10/2007 12:17'!
heading: anObject level: anInteger
	self deprecatedApi.
	self heading level: anInteger; with: anObject! !

!WACachedDocument methodsFor: '*js' stamp: 'kph 7/14/2007 12:29'!
clear
	

	"Clear the cached mimeDocument, will cause
	it to be re-read from disk at next access."

	
	mimeDocument _ nil! !

WACachedDocument subclass: #WANotCachedDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Document'!

!WANotCachedDocument class methodsFor: 'instance-creation' stamp: 'kph 7/14/2007 14:08'!
fileName: aFileName
	 
	^ self fullFileName: aFileName ! !

!WANotCachedDocument methodsFor: 'public' stamp: 'kph 7/14/2007 14:13'!
asMIMEDocumentType: type
	 
	 mimeDocument := nil.
	^ super asMIMEDocumentType: type! !

!WANotCachedDocument methodsFor: 'public' stamp: 'kph 7/14/2007 13:59'!
notCached

	^ true! !

!WATagBrush methodsFor: '*js-convenience' stamp: 'gk 5/5/2006 11:46'!
idNotNil: aString
	aString ifNotNil: [
		self attributeAt: 'id' put: aString]! !

!WATagBrush methodsFor: '*js-convenience' stamp: 'ul 6/24/2007 14:44'!
tooltip: stringOrTooltip
	"Using boxover, but only if current user wants them.
	See Q2StandardScripts>>boxover which is a slightly hacked/triimmed
	version of the original code. <stringOrTooltip> is either a String or
	a Q2BoxoverTooltip, see its class comment."

	stringOrTooltip ifNil: [^self].
	(Q2Session current noDb not and: [	Q2Session current currentUserSettings showToolTips]) ifFalse: [^self].
	^self title: (
		stringOrTooltip isString
			ifTrue: ['body=[', stringOrTooltip, ']']
			ifFalse: [ stringOrTooltip printString]) "then it must be a Q2BoxoverTooltip"! !

!WADocumentHandler methodsFor: '*js-override' stamp: 'kph 7/19/2007 13:50'!
mimeDocument

	"seaside jetsam extension 07, 

	enables documentClasses to signal respond with doNotCache by implementing #notCached"


	^ (mimeDocument isNil
			or: [document respondsTo: #notCached])
		ifTrue: [mimeDocument := document asMIMEDocumentType: mimeType]
		ifFalse: [mimeDocument]! !

!WADocumentHandler methodsFor: '*js-override' stamp: 'kph 7/19/2007 13:48'!
response

	"seaside jetsam extension 07, 

	enables documentClasses to signal respond with doNotCache by implementing #notCached"


	| response |
	response := WAResponse new.
	response contents: self mimeDocument contentStream text.
	response contentType: (mimeType ifNil: [self mimeDocument contentType]).
 
	(document respondsTo: #notCached) 
		ifTrue: [ response doNotCache ]
		ifFalse: [ response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT' ].

	fileName ifNotNil: [ response attachmentWithFileName: fileName ].
	^ response! !

PackageInfo subclass: #JetsamSeasidePackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Info'!

!JetsamSeasidePackageInfo class methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:34'!
initialize
	[self new register] on: MessageNotUnderstood do: ["must be an old version of PackageInfo"] ! !

!JetsamSeasidePackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:16'!
additionalFiles

	^#()! !

!JetsamSeasidePackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:16'!
changesText

	^ 'version 1:
  Initial public release.'! !

!JetsamSeasidePackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:53'!
methodCategoryPrefix
 
	^ methodCategoryPrefix ifNil: [methodCategoryPrefix := '*js']

 ! !

!JetsamSeasidePackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:33'!
packageName

	^ 'Seaside28Jetsam'! !

!JetsamSeasidePackageInfo methodsFor: 'accessing' stamp: 'kph 7/19/2007 11:15'!
prerequisitePackages
	^ #( 'Ma object serialization' )! !

!JetsamSeasidePackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:42'!
readmeText

	^'Base package extensions that other Jetsam, or other Seaside packages might need

	note: the method category prefix for SeasideJetsam is *js- or *js-override
	this still leaves some room for categorizing the method properly

ext 01: WAConfiguration-hasPreferenceGroup;
ext 02: WACachedDocument-clear to ensure next access the document is re-read from disk.
ext 03: WATagBrush-idNotNil: convenience method for setting ids.
ext 04: WAImageTag-fileName: restore old api, so that it can be used even though deprecated.
ext 05: WAHtmlCanvas-heading:level: restore old api, so that it can be used even though deprecated.
ext 06: WASession-download: contents mimeType: mimeType filename: fileName
	    Enables an anchor to respond with the file content to be downloaded.
ext 07: WADocumentHandler-mimeDocument/response
	   Enables documentClasses to signal respond with doNotCache by implementing #notCached
ext 08: WABatchedList-totalSize accessor
ext 09: WANotCachedDocument - document that doesnt want to be cached in memory
ext 10: WALibrary names and hence urls are not tied to the class name,  #libraryName can be specified.
ext 11: WAFileHandler-responseAt:ifAbsent:/libraryAt:ifAbsent:
	    This resolution process enables the libarary resolved by the url to decide who serves the document. 
		(the default behaviour is hardwired such that that library class itself has to serve the content).
ext 12: WAFileHandlerPlus and WAFileHandlerPlusTest
		- see class comment for details.
		- override seaside defaults in your project, and also serve from DISK if you wish.
'! !

!JetsamSeasidePackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:33'!
systemCategoryPrefix
	^ 'Seaside28Jetsam'! !
JetsamSeasidePackageInfo initialize!
